# !/usr/bin/perl -w
use strict;

my $type = $ARGV[1]; # gene; matrix
my $k_para = $ARGV[2]; # set the k of the k-shortest paths for generating the parameter file
my $k_extend = $ARGV[3]; # set the k of the maximal extended nodes (maximal intermediate nodes which can be extended, default 4)
open( in1, "<$ARGV[0]" );
my %gene = ();
my %interaction = ();
my $n_edge = 0;
my $n_gene = 0;
while( my $line = <in1> ) {
	chomp( $line );
	
	my ( $id1, $id2, $weight, $decs1 ) = split( /\t/, $line, 4 );
	
	if( $weight eq 'NA' ) {
		$weight = 1;
	}
	
	# my $dist = 1 - $weight;
	my $dist = $weight;
	# $dist = int( $dist * 10000 + 0.5 );
	
	$gene{ $id1 } = 'yes';
	$gene{ $id2 } = 'yes';
	$interaction{ "$id1:$id2" } = $dist;
	$interaction{ "$id2:$id1" } = $dist;
	
	$n_edge++;
}
close( in1 );

my @id = sort { $a <=> $b } keys %gene;
if( $type eq 'gene' ) {
	print join( "\n", @id ); exit;
}
$n_gene = $#id + 1;

if( $type eq 'para' ) {
	print join( "\n", $n_gene, $n_edge, $k_para, $k_extend );
	exit;
}

print ( $#id + 1 );
print "\n";
for( my $i = 0; $i <= $#id; $i++ ) {
	my $data = '';
	for( my $j = 0; $j <= $#id; $j++ ) {
		if( $j == $i ) {
			$data = $data."0\t";
			next;
		}
		
		if( !exists( $interaction{ $id[$i].":".$id[$j] } ) ) {
			$data = $data."-1\t";
			next;
		}
		
		$data = $data.$interaction{ $id[$i].":".$id[$j] }."\t";
	}
	
	chop $data;
	
	print $data."\n";
}
