#!/usr/bin/perl -w
use strict;

my $infile1 = $ARGV[0]; # seed gene list (may with attributes)
my $infile2 = $ARGV[1]; # shortest_path matrix
my $infile3 = $ARGV[2]; # "gse9055_entrez_id_hprd_ppi.gene_lst.txt";
# my $diff_cut = $ARGV[3];

# ----- identify differientially expressed genes -----
open( in1, "<$infile1" );
#my $header = <in1>;
my %dig = (); # the list of DIGs
while( my $line = <in1> ) {
	chomp( $line );
	my ( $id, @attribute ) = split( /\t/, $line );
	
	#if( $down >= $diff_cut || $up >= $diff_cut ) {
		# push( @dig, $id );
		$dig{ $id } = 'yes';
	#}
}
close( in1 );

# ----- construct the mapping table between line no. and gene_id -----
open( in2, "<$infile3" );
my %line2id = ();
my $i_line = 0;
while( my $id = <in2> ) {
	$i_line++;
	chomp( $id );
	$line2id{ $i_line } = $id;
}
close(in2);

# ----- extract the sub-matrix from shortest_path result file -----
open( in3, "<$infile2" );
my $i1 = 0;
while( my $line = <in3> ) {
	chomp( $line );
	$i1++;
	my $id1 = $line2id{ $i1 };
	
	my @dist = split( /\t/, $line );
	my $i2 = 0;
	for( my $i = 0; $i <= $#dist; $i++ ) {
		$i2++;
		my $id2 = $line2id{ $i2 };
		my $distance = $dist[$i];
		
		if( exists( $dig{ $id1 } ) && exists( $dig{ $id2 } ) ) {
			# $data_line = $data_line.$distance."\t";
			print join( "\t", $id1, $id2, $distance );
			print "\n";
		}
	}
	
	# chop( $data_line );
	# print $data_line, "\n";
}
close( in3 );
