/*********************** graph.cpp ******************/
#include "graph.h"
/*// edge
edge & edge::operator =(edge &e){
    this ->endvex = e.endvex;
    this ->fromvex = e.fromvex;
    this ->weight = e.weight;
    return *this;
}*/
// Queue
void Queue::enQueue(long iNode, float iDist, long iPrev){
    DijItem * temp = new DijItem();
    temp ->iNode = iNode;
    temp ->iDist = iDist;
    temp ->iPrev = iPrev;
    temp ->next = NULL;
    if(this ->length){
        DijItem * p = this ->root;
        while(p ->next)
            p = p ->next;
        p ->next = temp;
    }
    else
        this ->root = temp;
    this ->length ++;
}

void Queue::dequeue(long& iNode, float& iDist, long& iPrev){
    if(!this ->length)
        exit(0);
    DijItem * temp = this->root;
    iNode = temp ->iNode;
    iDist = temp ->iDist;
    iPrev = temp ->iPrev;

    this ->root = this ->root ->next;
    this ->length --;
    delete temp;
}

// Graph
void Graph::printGraph(){
    cout << MaxVertextNum << " * " << MaxVertextNum << " Graph" << endl;
    for(long i = 0; i < MaxVertextNum*MaxVertextNum; i ++){
        cout << ((adjmatrix[i] > MaxValue - 0.01) ? -1 : adjmatrix[i]) << ((i + 1)%MaxVertextNum?' ':'\n');
    }
    cout << endl;
}

long Graph::Dijkstra(long sp, float *& len, long *& lp){
    if(sp < 0 || sp >= MaxVertextNum)
        exit(0);

    len = new float[MaxVertextNum];
    lp = new long[MaxVertextNum];

    Queue q;
    long iNode, iPrev;
    float iCost, iDist;
    int i;

    for(i = 0; i < MaxVertextNum; i ++){
        len[i] = MaxValue;
        lp[i] = MaxValue;
    }

    len[sp] = 0;
    lp[sp] = MaxValue;

    q.enQueue(sp, 0, MaxValue);
    while(q.getLength()){
        q.dequeue(iNode, iDist, iPrev);
        for(i = 0; i < MaxVertextNum; i ++){
            if((iCost = this ->adjmatrix[iNode * MaxVertextNum + i]) <= MaxValue - 0.01){
                if(len[i] >= MaxValue - 0.01 || len[i] > iDist + iCost){
                    len[i] = iDist + iCost;
                    lp[i] = iNode;
                    q.enQueue(i, len[i], lp[i]);
                }
            }
        }
    }
    return MaxVertextNum;
}  

long Graph::Init(char *matrixfile)
{
	ifstream fin;
        fin.open(matrixfile);
        long i, m;
        fin >> m;
        this ->MaxVertextNum = m;
        this ->adjmatrix = new float[m * m];
        for(i = 0; i < m*m; i ++){
            fin >> adjmatrix[i];
            if(adjmatrix[i] <= -0.1) adjmatrix[i] = MaxValue;
		}
	return m;
}

/* int Graph::Prim(edge *& CT){
    int i, j, k, t, m;
    float min, w;

    CT = new edge[MaxVertextNum - 1];

    for(i = 0; i < MaxVertextNum - 1; i ++){
        CT[i].fromvex = 0;
        CT[i].endvex = i + 1;
        CT[i].weight = adjmatrix[i + 1];
    }
    for(k = 1; k < MaxVertextNum - 1; k ++){
        min = MaxValue;
        m = k - 1;
        for(j = k - 1; j < MaxVertextNum - 1; j ++)
            if(CT[j].weight < min){
                min = CT[j].weight;
                m = j;
            }
        edge temp = CT[k - 1];
        CT[k - 1] = CT[m];
        CT[m] = temp;

        j = CT[k - 1].endvex;

        for(i = k; i < MaxVertextNum - 1; i ++){
            t = CT[i].endvex;
            if(t != j){
                w = adjmatrix[j * MaxVertextNum + t];
                if(w < CT[i].weight){
                    CT[i].weight = w;
                    CT[i].fromvex = j;
                }
            }
        }
    }
    return MaxVertextNum - 1;
}

int Graph::Kruskal(edge *& C){

    C = new edge[MaxVertextNum - 1];

    int i, j;
    bool *s = new bool[MaxVertextNum * MaxVertextNum];
    int n = MaxVertextNum;
    int k = 1, d = 0, m1 = 0, m2 = 0;
    // Get the sorted edge;
    edge * GE = new edge[MaxVertextNum * (MaxVertextNum - 1) / 2];
    int edgenum = 0;
    for(i = 0; i < MaxVertextNum; i ++){
        for(j = i + 1; j < MaxVertextNum; j ++){
            if(adjmatrix[i * MaxVertextNum + j] <= MaxValue - 0.01){
                GE[edgenum].fromvex = i;
                GE[edgenum].endvex = j;
                GE[edgenum ++].weight = adjmatrix[i * MaxVertextNum + j];
            }
        }
    }
    for(i = 0; i < edgenum - 1; i ++){
        for(j = i + 1; j < edgenum; j ++){
            if(GE[i].weight > GE[j].weight){
                edge temp = GE[i];
                GE[i] = GE[j];
                GE[j] = temp;
            }
        }
    }
    // Vertext Sets;
    for(i = 0; i < n; i ++){
        for(j = 0; j < n; j ++){
            s[i * MaxVertextNum + j] = (i == j);
        }
    }
    // Get the Mini edges
    while(k < n && d < edgenum){
        for(i = 0; i < n; i ++){
            if(s[i * MaxVertextNum + GE[d].fromvex])
                m1 = i;
            if(s[i * MaxVertextNum + GE[d].endvex])
                m2 = i;
        }
        if(m1 != m2){
            C[k - 1] = GE[d];
            k ++;
            for(j = 0; j < n; j ++){
                s[m1 * MaxVertextNum + j] = s[m1 * MaxVertextNum + j] || s[m2 * MaxVertextNum + j];
                s[m2 * MaxVertextNum + j] = false;
            }
        }
        d ++;
    }
    delete [] GE;
    for(i = 0; i < MaxVertextNum; i ++){
        if(s[i * MaxVertextNum]){
            for(j = 1; j < MaxVertextNum; j ++){
                if(!s[i * MaxVertextNum + j])
                    break;
            }
            if(j != MaxVertextNum){
                delete [] s;
                return -1;
            }
            else{
                delete [] s;
                return MaxVertextNum - 1;
            }
        }
    }
    delete [] s;
    return -1;
}
*/
