/* k Shortest Paths in O(E*log V + L*k*log k) time (L is path length)
   Following David Eppstein's "Finding the k Shortest Paths" March 31, 1997 draft
   (http://www.ics.uci.edu/~eppstein/
    http://www.ics.uci.edu/~eppstein/pubs/p-kpath.ps)
   */


#include "graph.h"
#include <strstream>
#include <iostream>
#include<fstream>

int main(long argc, char *argv[])
{
  long k;
  long source, dest;
  ifstream vecnt;
   ifstream istr;
  long vercnt,ecent;
  ifstream fsrc,fsink;
  fsrc.open(argv[3]);
  vecnt.open(argv[1]);
  vecnt>>vercnt>>ecent>>k;
  vecnt.close();
  vecnt.clear();
  Graph graph;
/////////////////////////////////////////////////////////////////////////
 
  
graph.nStates=vercnt;
ofstream o,o1;
o.open(argv[5]);
o1.open(argv[6]);
while ( (fsrc >> source) != NULL)
{
   fsink.open(argv[4]);
   while((fsink>>dest) != NULL)
  {
       if(dest>source)
       {

            istr.open(argv[2]);
            istr>>graph;
            istr.close();
            istr.clear();
            List<List<GraphArc *> > *paths = bestPaths(graph, source, dest, k);
           for ( ListIter<List<GraphArc *> > pathIter(*paths) ; pathIter ; ++pathIter ) {
                float pathWeight = 0;
                GraphArc *a;
                    for ( ListIter<GraphArc *> arcIter(pathIter.data()) ; arcIter ; ++arcIter ) {
                           a = arcIter.data();
                           pathWeight += a->weight;
                           o << *a << ' ';
                         }
                                      o<<"-1"<<"  ";
           }
        }
   }
   fsink.close();
   fsink.clear();
}

fsrc.close();
fsrc.clear();

  fsrc.open(argv[3]);
while ( (fsrc >> source) != NULL)
{
   fsink.open(argv[4]);
   while((fsink>>dest) != NULL)
  {
       if(dest>source)
       {

            istr.open(argv[2]);
            istr>>graph;
            istr.close();
            istr.clear();
            List<List<GraphArc *> > *paths = bestPaths(graph, source, dest, 1);
           for ( ListIter<List<GraphArc *> > pathIter(*paths) ; pathIter ; ++pathIter ) {
                float pathWeight = 0;
                GraphArc *a1;
                    for ( ListIter<GraphArc *> arcIter(pathIter.data()) ; arcIter ; ++arcIter ) {
                           a1 = arcIter.data();
                           pathWeight += a1->weight;
                           o1 << *a1 << ' ';
                         }
                                      o1<<"-1"<<"  ";
           }
        }
   }
   fsink.close();
   fsink.clear();
}
  return 0;
}
